VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fest Einfach
   Caption         =   "Pneumatic Robots : Greifer"
   ClientHeight    =   5295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7545
   Icon            =   "PneuGreif.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   5295
   ScaleWidth      =   7545
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CommandButton cmdEnde 
      Caption         =   "ENDE"
      Height          =   375
      Left            =   5880
      TabIndex        =   1
      Top             =   4200
      Width           =   1335
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "START"
      Height          =   375
      Left            =   5880
      TabIndex        =   0
      Top             =   4680
      Width           =   1335
   End
   Begin VB.Label lblStatus 
      Alignment       =   2  'Zentriert
      Caption         =   "STARTen"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   20.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   480
      TabIndex        =   2
      Top             =   360
      Width           =   6615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' ------------------------------------------------------------------------------
'
' frmMain(PneuGreif.frm)                                  Ulrich Mller 27.12.99
'                                                         Procida 400NT    VB6.0
' Pneumatischer Greifer : VB6 Adaption des LLWin Programms Greifer.MDL
'                         der Pneumatic Robots
' Zyklus : GreifArm geht nach Position A, holt das Teil und setzt es auf
' Pos. B ab, Leerrunde, Teil zurck nach A, Leerrunde.
'
' Der jeweilige Status wird auf der Form angezeigt (lblStatus)
' ggf. zustzlich noch das InterfacePanel anzeigen (OpenInterface)
'
' Nutzung umFish.DLL
'
' ggf. den PortNamen in Form_Load anpassen (eingestellt : "COM1")
' Armxx und Greiferxx :
' Die Waitfunktion wurden in die Funktionen integriert.
' Ebenfalls die Resetfunktion, sie knnte auch zentraler in WaitForTime
' eingebaut werden (wenn der Eingang immer dafr zur Verfgung steht).
' Die Statusanzeige wurde vor WaitForTime plaziert, um eine Anzeige zu
' gewhrleisten (danach wird nichts).
'
' ------------------------------------------------------------------------------

Option Explicit

' --- Modellkonstanten -----------------------

Const cvArmA = 1, cvArmB = 2, cvGreifer = 3   ' --- MagnetVentile
Const cmKompressor = 4                        ' --- Motor
Const ctReset = 8                             ' --- Taster




Private Sub ArmPosA()

' --- Arm nach Position A ---------------

  SetMotor ft, cvArmB, ftiAus
  SetMotor ft, cvArmA, ftiEin
  If GetInput(ft, ctReset) Then Exit Sub         ' --- Abbruch durch Reset
  lblStatus = "Position A"
  WaitForTime ft, 2000
  
End Sub


Private Sub ArmPosB()

' --- Arm nach Position B ---------------

  SetMotor ft, cvArmA, ftiAus
  SetMotor ft, cvArmB, ftiEin
  If GetInput(ft, ctReset) Then Exit Sub         ' --- Abbruch durch Reset
  lblStatus = "Position B"
  WaitForTime ft, 2000
  
End Sub

Private Sub GreiferAuf()

' --- Greifer ffnen ---

  SetMotor ft, cvGreifer, ftiAus
  If GetInput(ft, ctReset) Then Exit Sub         ' --- Abbruch durch Reset
  lblStatus = "Greifer Auf"
  WaitForTime ft, 2000
  
End Sub

Private Sub GreiferZu()

' --- Greifer schlieen ----

  SetMotor ft, cvGreifer, ftiEin
  If GetInput(ft, ctReset) Then Exit Sub         ' --- Abbruch durch Reset
  lblStatus = "Greifer Zu"
  WaitForTime ft, 2000
  
End Sub


Private Sub GreifMain()

' --- Hauptprogramm, Schleife, die ber NotHalt bzw. Reset beendet wird ---

  SetMotor ft, cmKompressor, ftiEin    ' --- Startphase
  WaitForTime ft, 6000
  GreiferAuf
  ArmPosA
  lblStatus = "Anlage ready"
  DoEvents
  
  Do                                  ' --- Schleife bis NotHalt oder Reset
    GreiferZu
    ArmPosB
    GreiferAuf
    ArmPosA
    ArmPosB
    GreiferZu
    ArmPosA
    GreiferAuf
    ArmPosB
    ArmPosA
  Loop Until NotHalt Or GetInput(ft, ctReset)
  
End Sub

Private Sub cmdAction_Click()

' --- Starten / Beenden der Trsteuerung ---

  If cmdAction.Caption = "START" Then       ' --- Start
    lblStatus = "Gestartet"
    cmdEnde.Enabled = False                 '     um ein wildes Beenden des
    cmdAction.Caption = "HALT"              '     gesamten Programms zu verhindern
    NotHalt = False                         ' --- Endesteuerung
    GreifMain                               ' --- Hin- und Hergreifen
  Else                                      ' --- Beenden
    NotHalt = True                          '     Ende einleiten
  End If
                                            ' --- Ende
  ClearMotors ft                            '     alle M-Ausgnge aus
  cmdEnde.Enabled = True                    '     ENDE wieder zulassen
  cmdAction.Caption = "START"               '     erneuten START zulassen
  lblStatus = "START/ENDE"
  cmdEnde.SetFocus
  
End Sub


Private Sub cmdEnde_Click()

  Unload Me
  
End Sub


Private Sub Form_Load()
    
' --- Programm Initialisierung ---

  If OpenInterface(ft, "COM1") = ftiFehler Then ' --- COM1 ggf. Anpassen --COM1 ---
    MsgBox "InterfaceProblem", vbExclamation + vbOKOnly, "PneuTuer"
    Unload Me
  End If
  
End Sub


Private Sub Form_Unload(Cancel As Integer)

' --- Aufrumen ---

  CloseInterface ft
  
End Sub


