// ----------------------------------------------------------------------------
//
// umFish(umFish.PAS)                                     Ulrich Mller 23.6.99
//                                                        Procida 400NT Delphi4
// Deklarationen und Variable zu umFish.DLL v1.2
// sowie zustzliche Funktionen (WaitForInput sollte bei Einsatz mit
// Delphi3 gestrichen oder modifiziert werden : opt. Parameter)
// Parameter: LongInt sind eine Konzession an Delphi3. Richtiger wre
// LongWord (DLL: DWORD)
// Die kritischen Funktionen von umFish.DLL wurden redefiniert und
// mit Application.ProcessMessages unterbrechbar gemacht.
// Die Abbrechbarkeit wird ber die Variable NotHalt und die Escape-Taste
// hergestellt.
//
// ----------------------------------------------------------------------------

unit umFish;

interface
const
  ftiAus=0; ftiEin=1; ftiLinks=1; ftiRechts=2;
  ftiFehler=$0001FFFF;

type TftiDCB = record
  hCom: LongInt;
  PortID: LongInt;
  LPTDelay: LongInt;
  LPTAnalog: LongInt;
  InputStatus: LongInt;
  MotorStatus: LongInt;
  end;
type TpftiDCB = ^TftiDCB;

var
  ftiDCB: TftiDCB; pftiDCB: TpftiDCB = @ftiDCB;
  NotHalt: Boolean;

function OpenInterface(ft: TpftiDCB; PortName: string):LongInt;
       stdcall; external 'umFish.dll';
function CloseInterface(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function ClearMotors(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll';
function SetMotors(ft: TpftiDCB; MotorStatus:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetMotor(ft: TpftiDCB; MotorNr, Direction:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function SetLamp(ft: TpftiDCB; LampNr, OnOff:LongInt):LongInt;
       stdcall; external 'umFish.dll';
function StartDriver():LongInt; stdcall; external 'umFish.dll';
function StopDriver():LongInt; stdcall; external 'umFish.dll';

function GetInputs(ft: TpftiDCB):LongInt;
function GetInput(ft: TpftiDCB; InputNr:LongInt):Boolean;
function GetAnalog(ft: TpftiDCB; AnalogNr:LongInt):LongInt;
function WaitForInput(ft: TpftiDCB; InputNr: LongInt; OnOff: Boolean = true):LongInt;
procedure WaitForTime(ft: TpftiDCB; mSek:LongInt);

implementation

uses
  Windows, Messages, SysUtils, Forms, Dialogs;

function umGetInputs(ft: TpftiDCB):LongInt;
       stdcall; external 'umFish.dll' name 'GetInputs';
function umGetInput(ft: TpftiDCB; InputNr:LongInt):LongInt;
       stdcall; external 'umFish.dll' name 'GetInput';
function umGetAnalog(ft: TpftiDCB; AnalogNr:LongInt):LongInt;
       stdcall; external 'umFish.dll' name 'GetAnalog';

function GetInputs(ft: TpftiDCB):LongInt;
begin
  Result := umGetInputs(ft);
  Application.ProcessMessages;
end;

function GetInput(ft: TpftiDCB; InputNr: LongInt):Boolean;
begin
  Result := (umGetInput(ft, InputNr) = -1);
  Application.ProcessMessages;
end;

function GetAnalog(ft: TpftiDCB; AnalogNr: LongInt):LongInt;
begin
  Result := umGetAnalog(ft, AnalogNr);
  Application.ProcessMessages;
end;

function WaitForInput(ft: TpftiDCB; InputNr: LongInt; OnOff: Boolean = true):LongInt;
// --- Warten bis Eingang = OnOff wird ---------------------------------
begin
  repeat
    Application.ProcessMessages;       // --- Unterbrechbarkeit
    if NotHalt OR (GetAsyncKeyState(VK_ESCAPE) <> 0) then
    begin                              // --- Abbrechbarkeit
      Result := ftiFehler;
      exit;
    end;
  until (umGetInput(ft, InputNr) = -1) = OnOff;
  Result := ft.InputStatus;
end;

procedure WaitForTime(ft: TpftiDCB; mSek:LongInt);
// --- Eine vorgegebene Zeit warten --------------
var sZeit, nSek: DWORD;
begin
  nSek  := mSek;
  sZeit := GetTickCount();
  repeat
    Application.ProcessMessages;     // --- Unterbrechbarkeit
    umGetInputs(ft);                 //     REfresh Interface
  until NotHalt OR (GetTickCount() - sZeit > nSek) OR (GetAsyncKeyState(VK_ESCAPE)<>0);
end;
end.
